/*
*   Routines for rotation matrix
*   (c) 10.4.2001 Ingo D. Rullhusen
*/

#include <math.h>

void rotmat( double rot[3][3],
             double fac, double psi1, double scan, double psi2,
             double theta, double phi )
{
   int i, j, k;
   double tmprot1[3][3], tmprot2[3][3];

   for ( i=0; i<3; i++ )
   {
      for ( j=0; j<3; j++ )
         rot[i][j] = 0.0;
   }
   rot[0][0] = fac;
   rot[1][1] = fac;
   rot[2][2] = fac;

   for ( i=0; i<3; i++ )
   {
      for ( j=0; j<3; j++ )
         tmprot2[i][j] = rot[i][j];
   }
   tmprot1[0][0] = cos(psi1);
   tmprot1[0][1] = -sin(psi1);
   tmprot1[0][2] = 0.0;
   tmprot1[1][0] = sin(psi1);
   tmprot1[1][1] = cos(psi1);
   tmprot1[1][2] = 0.0;
   tmprot1[2][0] = 0.0;
   tmprot1[2][1] = 0.0;
   tmprot1[2][2] = 1.0;
   for ( i=0; i<3; i++ )
   {
      for ( j=0; j<3; j++ )
      {
         rot[i][j] = 0.0;
         for ( k=0; k<3; k++ ) rot[i][j] += tmprot1[i][k]*tmprot2[k][j];
      }
   }

   for ( i=0; i<3; i++ )
   {
      for ( j=0; j<3; j++ )
         tmprot2[i][j] = rot[i][j];
   }
   tmprot1[0][0] = cos(scan);
   tmprot1[0][1] = 0.0;
   tmprot1[0][2] = sin(scan);
   tmprot1[1][0] = 0.0;
   tmprot1[1][1] = 1.0;
   tmprot1[1][2] = 0.0;
   tmprot1[2][0] = -sin(scan);
   tmprot1[2][1] = 0.0;
   tmprot1[2][2] = cos(scan);
   for ( i=0; i<3; i++ )
   {
      for ( j=0; j<3; j++ )
      {
         rot[i][j] = 0.0;
         for ( k=0; k<3; k++ ) rot[i][j] += tmprot1[i][k]*tmprot2[k][j];
      }
   }

   for ( i=0; i<3; i++ )
   {
      for ( j=0; j<3; j++ )
         tmprot2[i][j] = rot[i][j];
   }
   tmprot1[0][0] = cos(psi2);
   tmprot1[0][1] = -sin(psi2);
   tmprot1[0][2] = 0.0;
   tmprot1[1][0] = sin(psi2);
   tmprot1[1][1] = cos(psi2);
   tmprot1[1][2] = 0.0;
   tmprot1[2][0] = 0.0;
   tmprot1[2][1] = 0.0;
   tmprot1[2][2] = 1.0;
   for ( i=0; i<3; i++ )
   {
      for ( j=0; j<3; j++ )
      {
         rot[i][j] = 0.0;
         for ( k=0; k<3; k++ ) rot[i][j] += tmprot1[i][k]*tmprot2[k][j];
      }
   }

   for ( i=0; i<3; i++ )
   {
      for ( j=0; j<3; j++ )
         tmprot2[i][j] = rot[i][j];
   }
   tmprot1[0][0] = cos(theta);
   tmprot1[0][1] = 0.0;
   tmprot1[0][2] = sin(theta);
   tmprot1[1][0] = 0.0;
   tmprot1[1][1] = 1.0;
   tmprot1[1][2] = 0.0;
   tmprot1[2][0] = -sin(theta);
   tmprot1[2][1] = 0.0;
   tmprot1[2][2] = cos(theta);
   for ( i=0; i<3; i++ )
   {
      for ( j=0; j<3; j++ )
      {
         rot[i][j] = 0.0;
         for ( k=0; k<3; k++ ) rot[i][j] += tmprot1[i][k]*tmprot2[k][j];
      }
   }

   for ( i=0; i<3; i++ )
   {
      for ( j=0; j<3; j++ )
         tmprot2[i][j] = rot[i][j];
   }
   tmprot1[0][0] = cos(phi);
   tmprot1[0][1] = -sin(phi);
   tmprot1[0][2] = 0.0;
   tmprot1[1][0] = sin(phi);
   tmprot1[1][1] = cos(phi);
   tmprot1[1][2] = 0.0;
   tmprot1[2][0] = 0.0;
   tmprot1[2][1] = 0.0;
   tmprot1[2][2] = 1.0;
   for ( i=0; i<3; i++ )
   {
      for ( j=0; j<3; j++ )
      {
         rot[i][j] = 0.0;
         for ( k=0; k<3; k++ ) rot[i][j] += tmprot1[i][k]*tmprot2[k][j];
      }
   }

}
