//
// Class for separate value handling
// (c) 16.3.2007 Ingo D. Rullhusen
//

#ifndef SEPVALCLASS_H
#define SEPVALCLASS_H


class SEP_Z_VAL
{
   public:
      complex<double> a_val, phi_val;
      SEP_Z_VAL( complex<double> c1, complex<double> c2 )
               : a_val(c1), phi_val(c2) {}
      SEP_Z_VAL( complex<double> c = complex<double>(0.0,0.0) )
               : a_val(c), phi_val(c) {}
      SEP_Z_VAL( double c ) : a_val(c), phi_val(c) {}
      SEP_Z_VAL operator* ( const SEP_Z_VAL& op2 ) const { return( SEP_Z_VAL( a_val*op2.a_val, phi_val*op2.phi_val ) ); }
      SEP_Z_VAL operator+= ( const SEP_Z_VAL& op2 ) { return( SEP_Z_VAL( a_val+=op2.a_val, phi_val+=op2.phi_val ) ); }
      SEP_Z_VAL operator-= ( const SEP_Z_VAL& op2 ) { return( SEP_Z_VAL( a_val-=op2.a_val, phi_val-=op2.phi_val ) ); }
};


#endif
