//
// Class for sparse matrix
// (c) 16.3.2007 Ingo D. Rullhusen
//

#ifndef SMCLASS_H
#define SMCLASS_H


#include <fstream>

#include <sparse_matrix.h>

using namespace std;


template<typename data_type>
class SparseMatrix
{
   public:
      bool symmU;  // upper part of symmetric matrix
      int nofrows, totlen;
      int *first_ele, *colid;
      data_type *ele;

      SparseMatrix();
      SparseMatrix( bool symmU, int nofrows, int totlen );
      SparseMatrix( fstream &bfile );
      SparseMatrix( const SparseMatrix<data_type> *SMin );
      ~SparseMatrix();

      data_type operator()( int index1, int index2 ) const;

      void vecmult( data_type *Vin, data_type *Vout ) const;

      void to_binary( fstream &bfile ) const;
      void profile_out( string filename ) const;
};


#endif
