//
//  Routines for VECT input/output
//  (c) 19.11.2003 Ingo D. Rullhusen
//

#ifndef VECT_H
#define VECT_H

#include <string>
#include <vector>
#include <math.h>

using namespace std;

class POLY
{
   public:
      int            color[3];  // rgb, 0...255, negative for default color
      int            nv;        // negative for closed loop
      vector<double> x, y, z;

      POLY();
      POLY( int nv, int r, int g, int b );
      ~POLY();
};


typedef vector<POLY> POLYLIST;


int vect_in( const string filename, POLYLIST *plist );

void vect_num( const double cp[3], const double ln[3], const double hgt[3],
               const int color[3], int no, POLYLIST *plist );

void vect_harrow( const double p[2], const double d,
                  const double rho, const double phi,
                  int r, int g, int b, POLYLIST *plist );

void vect_out( const string filename, POLYLIST *plist );

void delete_poly_list( POLYLIST *plist );


#endif
